      var visualizer = null;
      var rendering = false;
      var delayedAudible = null;
      var presets = {};
      var presetKeys = [];
      var presetIndexHist = [];
      var presetIndex = 0;
      var canvasButterchurn = document.getElementById('butterchurn');
   
      function connectToAudioAnalyzer(envelope) {
        if(delayedAudible) {
          delayedAudible.disconnect();
        }
        delayedAudible = audioContext.createDelay();
        delayedAudible.delayTime.value = 0.26;
        envelope.connect(delayedAudible)
        delayedAudible.connect(audioContext.destination);
        visualizer.connectAudio(delayedAudible);
      }

      function startRenderer() {
        requestAnimationFrame(() => startRenderer());
        visualizer.render();
      }

      setTimeout(function b() {
        startRenderer() ;
      }, 100);

      function nextPreset(blendTime = 5.7) {
        presetIndexHist.push(presetIndex);
        var numPresets = presetKeys.length;
        presetIndex = (presetIndex + 1) % numPresets;
        visualizer.loadPreset(presets[presetKeys[presetIndex]], blendTime);
        $('#presetSelect').val(presetIndex);
      }

      function prevPreset(blendTime = 5.7) {
        var numPresets = presetKeys.length;
        presetIndex = ((presetIndex - 1) + numPresets) % numPresets;
        visualizer.loadPreset(presets[presetKeys[presetIndex]], blendTime);
        $('#presetSelect').val(presetIndex);
      }

      $(document).keydown((e) => {
        if (e.which === 32 || e.which === 39) {
          nextPreset();
        } else if (e.which === 8 || e.which === 37) {
          prevPreset();
        } else if (e.which === 72) {
          nextPreset(0);
        }
      });

      $('#presetSelect').change((evt) => {
        presetIndexHist.push(presetIndex);
        presetIndex = parseInt($('#presetSelect').val());
        visualizer.loadPreset(presets[presetKeys[presetIndex]], 5.7);
      });

      function initPlayer() {
        presets = {};
        if (window.butterchurnPresets) {
          Object.assign(presets, butterchurnPresets.getPresets());
        }
        if (window.butterchurnPresetsExtra) {
          Object.assign(presets, butterchurnPresetsExtra.getPresets());
        }
        presets = _(presets).toPairs().sortBy(([k, v]) => k.toLowerCase()).fromPairs().value();
        presetKeys = _.keys(presets);

        var presetSelect = document.getElementById('presetSelect');
        for(var i = 0; i < presetKeys.length; i++) {
            var opt = document.createElement('option');
            opt.innerHTML = presetKeys[i].substring(0,60) + (presetKeys[i].length > 60 ? '...' : '');
            opt.value = i;
            presetSelect.appendChild(opt);
        }

        visualizer = butterchurn.default.createVisualizer(audioContext, canvasButterchurn, {
          width: 400,
          height: 300,
          pixelRatio: window.devicePixelRatio || 1,
          textureRatio: 1,
        });
        nextPreset(0);
      }

      initPlayer();
